package com.thebrokenrail.energonrelics.client.rei;

import com.thebrokenrail.energonrelics.EnergonRelics;
import com.thebrokenrail.energonrelics.client.rei.infuser.InfuserCategory;
import com.thebrokenrail.energonrelics.client.rei.reactor.ReactorFuelCategory;
import me.shedaniel.rei.api.EntryStack;
import me.shedaniel.rei.api.RecipeHelper;
import me.shedaniel.rei.api.plugins.REIPluginV0;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.util.Identifier;

@Environment(EnvType.CLIENT)
public final class EnergonRelicsPlugin implements REIPluginV0 {
    public static final Identifier INFUSING = new Identifier(EnergonRelics.NAMESPACE, "plugin/infusing");
    public static final Identifier REACTOR_FUEL = new Identifier(EnergonRelics.NAMESPACE, "plugin/reactor_fuel");

    @Override
    public Identifier getPluginIdentifier() {
        return new Identifier(EnergonRelics.NAMESPACE, "plugin");
    }

    @Override
    public void registerOthers(RecipeHelper recipeHelper) {
        recipeHelper.registerWorkingStations(INFUSING, EntryStack.create(EnergonRelics.INFUSER_BLOCK));
        recipeHelper.registerWorkingStations(REACTOR_FUEL, EntryStack.create(EnergonRelics.REACTOR_INPUT_BLOCK));

        recipeHelper.removeAutoCraftButton(INFUSING);
        recipeHelper.removeAutoCraftButton(REACTOR_FUEL);
    }

    @Override
    public void registerRecipeDisplays(RecipeHelper recipeHelper) {
        InfuserCategory.register(recipeHelper);
        ReactorFuelCategory.register(recipeHelper);
    }

    @Override
    public void registerPluginCategories(RecipeHelper recipeHelper) {
        recipeHelper.registerCategories(new InfuserCategory(), new ReactorFuelCategory());
    }
}
